using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.IO;

namespace WindowsApplication1
{
   [Serializable()] abstract class Figure 
    {
        public  Figure()
        {        }            
 //       public  Figure(Point point1, Point point2);
        
        public abstract void Draw(Graphics g);
        public abstract void DrawDash(Graphics g);
        
    }
   [Serializable()] class Rect:Figure 
    {
        private int x1, x2, y1, y2,x3,x4,y3,y4;
        public Rect(){}
        
        public Rect (Point point1, Point point2)
                    
         {
            x1 = point1.X; y1 = point1.Y; x2 = point2.X; y2 = point2.Y;

         }
         
         void norm(ref int x1, ref int y1, ref int x2, ref int y2)
        {         
          int a;
          if (x2 < 0) { x2 = 0; }
          if (y2 < 0) { y2 = 0; } 
          if (x1 > x2) { a = x1; x1 = x2; x2 = a; }  
          if (y1 > y2) { a = y1; y1 = y2; y2 = a; } 
        }  
      public override void Draw(Graphics g)
        {
          norm(ref x1, ref y1, ref x2, ref y2);
          Pen penBlack = new Pen(Color.Black, 1);
          Rectangle r = Rectangle.FromLTRB(x1, y1, x2, y2);
          g.DrawRectangle(penBlack, r);
        }
      public override void DrawDash(Graphics g)
        {
          norm(ref x1, ref y1, ref x2,ref y2);
          Pen mypen = new Pen(Color.Black, 1);
          mypen.DashStyle = System.Drawing.Drawing2D.DashStyle.Dash;
          Rectangle r = Rectangle.FromLTRB(x1, y1, x2, y2);
          g.DrawRectangle(mypen, r);
          x3 = x1; x4 = x2;
          y3 = y1; y4 = y2;
        }
     
             
      }
    }

